package schedframe.scheduling.manager.tasks;


import java.util.concurrent.ConcurrentHashMap;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import schedframe.scheduling.tasks.Job;
import schedframe.scheduling.tasks.JobInterface;
import schedframe.scheduling.tasks.Task;
import schedframe.scheduling.tasks.TaskInterface;


public abstract class AbstractJobRegistry /*extends ConcurrentHashMap<String, Job> */implements JobRegistry, Cloneable{
	
	private static final long serialVersionUID = 8409060063583755824L;
	
	private static Log log = LogFactory.getLog(AbstractJobRegistry.class);
	
	protected static final ConcurrentHashMap<String, Job> jobs = new ConcurrentHashMap<String, Job>();
	
	protected AbstractJobRegistry(){
		//log.warn("Methods from JobRegistry interface are not implemented.");
	}
	
	public boolean addJob(JobInterface<?> job) {
		jobs.put(job.getId(), (Job) job);
		return true;
	}

	public boolean addTask(TaskInterface<?> task) {
		if(jobs.containsKey(task.getJobId())){
			jobs.get(task.getJobId()).add((Task)task);
			return true;
		} else {
			return false;
		}
	}

	public Job getJob(String jobId){
		return jobs.get(jobId);
	}
	
	public JobInterface<?> getJobInfo(String jobID) {
		return jobs.get(jobID);
	}

	public TaskInterface<?> getTaskInfo(String jobID, String taskId) {
		Task task = null;
		Job job = jobs.get(jobID);
		
		if(job == null)
			return null;
		
		try {
			task = job.getTask(taskId);
		} catch (NoSuchFieldException e) {
			log.error(e.getMessage());
		}
		return task;
	}
	
	/*public List<JobInterface<?>> getActiveJobs() {
		log.error("getActiveJobs() not implemented.");
		return null;
	}

	public List<TaskInterface<?>> getActiveTasks() {
		log.error("getActiveTasks() not implemented.");
		return null;
	}*/

}
